`timescale 1 ns/1 ps

module testbench;

localparam T = 10;
localparam N = 8;

reg          test_clk, test_rstb;
reg          test_start;
reg  [N-1:0] test_dvsr, test_dvnd;
wire         test_ready, test_done;
wire [N-1:0] test_quo, test_rmd;

divider
#(
   .N    (N         )
) uut (
   .clk  (test_clk  ),
   .rstb (test_rstb ),
   .start(test_start),
   .dvsr (test_dvsr ),
   .dvnd (test_dvnd ),
   .ready(test_ready),
   .done (test_done ),
   .quo  (test_quo  ),
   .rmd  (test_rmd  )
);

always #T test_clk = ~test_clk;

initial begin
   test_clk = 0;
   test_rstb = 0;
   test_start = 0;
   test_dvsr = 5; test_dvnd = 122;
   @(negedge test_clk) test_rstb = 1; test_start = 1;
   @(negedge test_clk) test_start = 0;
   repeat (10) @(negedge test_clk);
   test_dvsr = 3; test_dvnd = 99; test_start = 1;
   @(negedge test_clk) test_start = 0;
   repeat (10) @(negedge test_clk);
   $stop;
end

endmodule