`timescale 1 ns/1 ps

module testbench;

localparam T = 10;

reg         test_clk, test_rstb;
reg         test_start;
reg   [4:0] test_i;
wire        test_ready, test_done;
wire [19:0] test_f;

fibonacci uut (
   .clk  (test_clk  ),
   .rstb (test_rstb ),
   .start(test_start),
   .i    (test_i    ),
   .ready(test_ready),
   .done (test_done ),
   .f    (test_f    )
);

always #T test_clk = ~test_clk;

initial begin
   test_clk = 0;
   test_rstb = 0;
   test_start = 0;
   test_i = 5;
   @(negedge test_clk) test_rstb = 1; test_start = 1;
   @(negedge test_clk) test_start = 0;
   repeat (10) @(negedge test_clk);
   test_i = 10; test_start = 1;
   @(negedge test_clk) test_start = 0;
   repeat (15) @(negedge test_clk);
   $stop;
end

endmodule